"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Modelify {
    constructor(schemeGenerator, codeGenerator, logger) {
        this.schemeGenerator = schemeGenerator;
        this.codeGenerator = codeGenerator;
        this.logger = logger;
    }
    generate(schemeSource) {
        let scheme = this.schemeGenerator.generate(schemeSource);
        return scheme.map(s => {
            let file = this.codeGenerator.generateClass(s);
            this.logger.log(`Generated model: ${file.fileName}`);
            return file;
        });
    }
}
exports.default = Modelify;
//# sourceMappingURL=Modelify.js.map