"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("../types/Type");
class ApiMethodParam {
    constructor(name, type, required, description) {
        this.name = name;
        this.type = type;
        this.required = required;
        this.description = description;
    }
    serialize() {
        return {
            name: this.name,
            type: this.type.serialize(),
            required: this.required,
            description: this.description
        };
    }
    static deserialize(raw) {
        return new ApiMethodParam(raw['name'], Type_1.Type.deserialize(raw['type']), raw['required'], raw['description']);
    }
}
exports.default = ApiMethodParam;
//# sourceMappingURL=ApiMethodParam.js.map