"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Type_1 = require("../types/Type");
class ClassField {
    constructor(name, type, description) {
        this.name = name;
        this.type = type;
        this.description = description;
    }
    serialize() {
        return {
            name: this.name,
            type: this.type.serialize(),
            description: this.description
        };
    }
    static deserialize(raw) {
        return new ClassField(raw['name'], Type_1.Type.deserialize(raw['type']), raw['description']);
    }
}
exports.default = ClassField;
//# sourceMappingURL=ClassField.js.map