"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ClassField_1 = require("./ClassField");
class ClassScheme {
    constructor(name, fields) {
        this.name = name;
        this.fields = fields;
    }
    serialize() {
        return {
            name: this.name,
            fields: this.fields.map(f => f.serialize())
        };
    }
    static deserialize(raw) {
        return new ClassScheme(raw['name'], raw['fields'].map(ClassField_1.default.deserialize));
    }
}
exports.default = ClassScheme;
//# sourceMappingURL=ClassScheme.js.map