"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
class BaseConsoleApplication {
    constructor() {
        this.env = process.env['NODE_ENV'] || 'development';
        this.isProducton = this.env == 'production';
    }
    die(error) {
        console.error(error);
        process.exit();
    }
    getArgs() {
        let result = {};
        process.argv.forEach(arg => {
            let test = arg.split('=');
            if (test[0] && test[1] && test[0][0] == '-') {
                result[test[0].replace('-', '')] = test[1];
            }
        });
        return result;
    }
    saveToFile(name, data) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                fs_1.writeFile(name, data, err => {
                    if (err) {
                        reject(err);
                        return;
                    }
                    resolve();
                });
            });
        });
    }
    readFile(name) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                fs_1.readFile(name, 'utf-8', (err, data) => {
                    if (err) {
                        reject(err);
                        return;
                    }
                    resolve(data);
                });
            });
        });
    }
    readDir(dir) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                fs_1.readdir(dir, (err, files) => {
                    if (err) {
                        reject(err);
                        return;
                    }
                    resolve(files);
                });
            });
        });
    }
}
exports.default = BaseConsoleApplication;
//# sourceMappingURL=BaseConsoleApplication.js.map