"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const JSONSchemeGenerator_1 = require("../infrastructure/schemeGeneration/JSONSchemeGenerator");
const JSONSchemeSource_1 = require("../infrastructure/schemeGeneration/sources/JSONSchemeSource");
const TypescriptCodeGenerator_1 = require("../infrastructure/codeGeneration/TypescriptCodeGenerator");
let schemeGenerator = new JSONSchemeGenerator_1.default();
let json = {
    "actions": [
        {
            "date": "29.06.2017",
            "title": "Покупка чего то",
            "subactions": [
                {
                    "date": "26.04.2016",
                    "title": "Вход в личный кабинет 2",
                    "subactions": []
                },
                {
                    "date": "26.04.2016",
                    "title": "Вход в личный кабинет 3",
                    "subactions": []
                }
            ]
        },
        {
            "date": "29.06.2017",
            "title": "Покупка чего то 2",
            "subactions": [
                {
                    "date": "26.04.2016",
                    "title": "Вход в личный кабинет 2",
                    "subactions": []
                },
                {
                    "date": "26.04.2016",
                    "title": "Вход в личный кабинет 3",
                    "subactions": []
                }
            ]
        }
    ]
};
//console.dir(json, {depth: null})
let cheme = schemeGenerator.generate(new JSONSchemeSource_1.default(json));
console.log('\n\n\n');
console.dir(cheme, { depth: null });
console.log('\n\n\n\n');
let codeGenerator = new TypescriptCodeGenerator_1.default();
cheme.forEach(s => {
    console.log(codeGenerator.generateClass(s).code.render());
    console.log('\n\n\n');
});
//# sourceMappingURL=Test.js.map